unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, HttpSrv, StdCtrls, shellapi, ComCtrls, ExtCtrls;

type
  TformMenuPrincipal = class(TForm)
    LWEB: TLabel;
    be: TStatusBar;
    Panel1: TPanel;
    ServidorHttp: THttpServer;
    bIniciar: TButton;
    bDetener: TButton;
    Label1: TLabel;
    txtRutaWeb: TEdit;
    txtNombrePaginaInicio: TEdit;
    Label2: TLabel;
    txtPuerto: TEdit;
    Label3: TLabel;
    nSDir: TButton;
    txtIPServidor: TEdit;
    Label4: TLabel;
    Panel2: TPanel;
    txtLog: TMemo;
    Splitter1: TSplitter;
    procedure bIniciarClick(Sender: TObject);
    procedure bDetenerClick(Sender: TObject);
    procedure ServidorHttpServerStarted(Sender: TObject);
    procedure ServidorHttpServerStopped(Sender: TObject);
    procedure ServidorHttpClientConnect(Sender, Client: TObject;
      Error: Word);
    procedure LWEBClick2(Sender: TObject);
    procedure nSDirClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ServidorHttpClientDisconnect(Sender, Client: TObject;
      Error: Word);
    procedure ServidorHttpGetDocument(Sender, Client: TObject;
      var Flags: THttpGetFlag);
    procedure ServidorHttpPostDocument(Sender, Client: TObject;
      var Flags: THttpGetFlag);
    procedure ServidorHttpPostedData(Sender, Client: TObject; Error: Word);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

uses WSocket;

{$R *.dfm}

procedure TformMenuPrincipal.bIniciarClick(Sender: TObject);
begin
  ServidorHttp.Stop;
  ServidorHttp.Addr := txtIPServidor.Text;
  ServidorHttp.DocDir := txtRutaWeb.Text;
  ServidorHttp.Port := txtPuerto.Text;
  ServidorHttp.DefaultDoc := txtNombrePaginaInicio.Text;
  ServidorHttp.Start;
end;

procedure TformMenuPrincipal.bDetenerClick(Sender: TObject);
begin
  ServidorHttp.Stop;
end;

procedure TformMenuPrincipal.ServidorHttpServerStarted(Sender: TObject);
begin
  bIniciar.Enabled := false;
  bDetener.Enabled := true;
  be.Panels[0].Text := 'Servidor iniciado el ' + DateToStr(date) +
      ' a  las ' + TimeToStr(Time);
  txtLog.Lines.Add(DateToStr(Date) + ' - ' + TimeToStr(Time) +  ' - Servidor Web Inciado');
  be.Refresh;
end;

procedure TformMenuPrincipal.ServidorHttpServerStopped(Sender: TObject);
begin
  bIniciar.Enabled := true;
  bDetener.Enabled := false;
  be.Panels[0].Text := 'Servidor detenido el ' + DateToStr(date) +
      ' a  las ' + TimeToStr(Time);
  txtLog.Lines.Add(DateToStr(Date) + ' - ' + TimeToStr(Time) +  ' - Servidor Web Detenido');
  be.Refresh;
end;

procedure TformMenuPrincipal.ServidorHttpClientConnect(Sender, Client: TObject;
  Error: Word);
begin
  txtLog.Lines.Add(DateToStr(Date) + ' - ' + TimeToStr(Time) +  ' - Cliente conectado');
  be.Panels[1].Text := TimeToStr(Time) + ' - Cliente conectado';
  be.Refresh;
end;

procedure TformMenuPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.nSDirClick(Sender: TObject);
begin
//  if OpenDialog1.Execute then
//    txtRutaWeb.Text := ExtractFilePath(OpenDialog1.FileName);
end;

procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ServidorHttp.Stop;
end;

procedure TformMenuPrincipal.ServidorHttpClientDisconnect(Sender,
  Client: TObject; Error: Word);
begin
  txtLog.Lines.Add(DateToStr(Date) + ' - ' + TimeToStr(Time) +  ' - Cliente desconectado');
end;

procedure TformMenuPrincipal.ServidorHttpGetDocument(Sender,
  Client: TObject; var Flags: THttpGetFlag);

begin
  txtLog.Lines.Add(DateToStr(Date) + ' - ' + TimeToStr(Time) +  ' - Cliente pide documento');

end;

procedure TformMenuPrincipal.ServidorHttpPostDocument(Sender,
  Client: TObject; var Flags: THttpGetFlag);
begin
  txtLog.Lines.Add(DateToStr(Date) + ' - ' + TimeToStr(Time) +  ' - Documento enviado a cliente');
end;

procedure TformMenuPrincipal.ServidorHttpPostedData(Sender,
  Client: TObject; Error: Word);
begin
  txtLog.Lines.Add(DateToStr(Date) + ' - ' + TimeToStr(Time) +  ' - Datos enviado a cliente');
end;

end.
